package org.pfsw.security;

import static org.junit.Assert.*;

import org.junit.Test;
import org.pfsw.security.testhelper.PrimitiveByteSquenceGenerator;

public class Base64UrlEncodedRandomStringGeneratorTest
{
  @Test
  public void test_toString()
  {
    Base64UrlEncodedRandomStringGenerator generator;
    
    generator = Base64UrlEncodedRandomStringGenerator.create(5);
    assertEquals("Base64UrlEncodedRandomStringGenerator()", generator.toString());
  }
  
  @Test
  public void test_generate()
  {
    Base64UrlEncodedRandomStringGenerator generator;
    
    generator = Base64UrlEncodedRandomStringGenerator.create(new PrimitiveByteSquenceGenerator());
    assertEquals("QUJDREVG", generator.generateString());
  }

  @Test
  public void test_generate_length()
  {
    Base64UrlEncodedRandomStringGenerator generator;
    
    generator = Base64UrlEncodedRandomStringGenerator.create(new PrimitiveByteSquenceGenerator());
    assertEquals("QUJ", generator.generateString(3));
    assertEquals("QUJDRE", generator.generateString(6));
    assertEquals("QUJDREVG", generator.generateString(8));
    assertEquals("QUJDREVGQU", generator.generateString(10));
    assertEquals("QUJDREVGQUJDREVGQUJDREV", generator.generateString(23));
  }
}