package org.pfsw.security.oauth.pkce;

import static org.junit.Assert.*;
import static org.pfsw.security.testhelper.UnitTestHelper.*;

import org.junit.Test;
import org.pfsw.security.testhelper.PrimitiveRandomStringGenerator;

public class AbstractPKCEGeneratorTest
{
  @Test
  public void test_generate()
  {
    ProofKeyForCodeExchange proofKey;
    String string = PrimitiveRandomStringGenerator.FIXED_PART + "1";

    proofKey = createGenerator().generate();
    assertPlainKey(proofKey);
    assertEquals(String.format("ProofKeyForCodeExchange('plain', '%s')", string), proofKey.toString());
  }

  // ============== helper methods ======================================

  private PKCEGenerator createGenerator()
  {
    return new AbstractPKCEGenerator(CodeChallengeMethod.PLAIN, new PrimitiveRandomStringGenerator())
    {
      @Override
      protected String createCodeChallenge(String codeVerifier)
      {
        return codeVerifier;
      }
    };
  }
}