package org.pfsw.security.testhelper;

import org.pfsw.security.oauth.pkce.PKCEGenerator;
import org.pfsw.security.oauth.pkce.PlainPKCEGenerator;
import org.pfsw.security.oauth.pkce.ProofKeyForCodeExchange;

/**
 * A PKCE generator that creates a new PlainPKCEGenerator instance for
 * each proof key to be generated. 
 */
public class AlwaysNewPlainPKCEGenerator implements PKCEGenerator
{
  @Override
  public ProofKeyForCodeExchange generate()
  {
    return PlainPKCEGenerator.create().generate();
  }
}
