package org.pfsw.security.testhelper;

import org.pfsw.security.oauth.pkce.PKCEGenerator;
import org.pfsw.security.oauth.pkce.ProofKeyForCodeExchange;
import org.pfsw.security.oauth.pkce.S256PKCEGenerator;

/**
 * A PKCE generator that creates a new S256PKCEGenerator instance for
 * each proof key to be generated. 
 */
public class AlwaysNewS256PKCEGenerator implements PKCEGenerator
{
  @Override
  public ProofKeyForCodeExchange generate()
  {
    return S256PKCEGenerator.create().generate();
  }
}
