// ===========================================================================
// CONTENT  : CLASS PrimitiveRandomStringGenerator
// AUTHOR   : Manfred Duchrow
// VERSION  : 1.0 - 24/04/2020
// HISTORY  :
//  24/04/2020  mdu  CREATED
//
// Copyright (c) 2020, by MDCS. All rights reserved.
// ===========================================================================
package org.pfsw.security.testhelper;

import org.pfsw.text.StringGenerator;

public class PrimitiveRandomStringGenerator implements StringGenerator
{
  public static final String FIXED_PART = "AAAABBBBCCCCDDDDEEEEFFFFGGGGHHHHIIIIJJJJKKKK"; // 44 chars (min 43 required!)

  public PrimitiveRandomStringGenerator()
  {
    super();
  }

  private int counter = 0;

  @Override
  public String generateString(int length)
  {
    return generateString().substring(0, length);
  }

  @Override
  public String generateString()
  {
    counter++;
    return FIXED_PART + counter;
  }
}
