package org.pfsw.security.x509;

import static org.junit.Assert.*;
import static org.pfsw.security.testhelper.UnitTestHelper.*;

import java.io.FileNotFoundException;
import java.io.IOException;

import org.junit.Test;
import org.pfsw.bif.exceptions.IORuntimeException;

public class X509TrustManagerBuilderTest
{
  @Test
  public void test_addTruststore__unknown_file()
  {
    try
    {
      X509TrustManagerBuilder.create().addTrustStore("unknown.jks", "password");
    }
    catch (RuntimeException e)
    {
      assertTrue(String.format("e is %s", e.getClass().getName()), e instanceof IORuntimeException);
      IORuntimeException ex = (IORuntimeException)e;
      assertTrue(String.format("ex is %s", ex.getClass().getName()), ex.getCause() instanceof FileNotFoundException);
    }
  }

  @Test
  public void test_addTruststore__invalid_file()
  {
    try
    {
      X509TrustManagerBuilder.create().addTrustStore(TESTDATA + "invalid-truststore.jks", "password");
    }
    catch (RuntimeException e)
    {
      assertTrue(String.format("e is %s", e), e instanceof IORuntimeException);
      IORuntimeException ex = (IORuntimeException)e;
      assertTrue(String.format("ex is %s", ex.getClass().getName()), ex.getCause() instanceof IOException);
    }
  }
  
  @Test
  public void test_addDefaultTrustStore__duplicate()
  {
    //@formatter:off
    MultiX509TrustManager trustManager = X509TrustManagerBuilder.create()
        .addDefaultTrustStore()
        .addDefaultTrustStore()
        .addTrustStore(TESTDATA + "truststore1.jks", "password")
        .build();
    //@formatter:on
    
    assertEquals(2, trustManager.getTrustManagers().size());
  }
}
